/*********************************************************************
 * S1L1.c - (Section 1, Lesson 1) SENDING AN INTEGER TO THE HOST
 *          This is the RTDX Target Code for Section 1, Lesson 1
 *
 * This example sends integer value 5 to the host
 ********************************************************************/

#include <rtdx.h>
#include <codec.h>
#include <mcbsp54.h> 
#include "target.h"     /* defines TARGET_INITIALIZE()              */
#include <stdio.h>      /* C_I/O                                    */

HANDLE hHandset;
s16 data;
static short sample_var;

RTDX_CreateOutputChannel( ochan );	//declare a global output channel
 
void main()
{
        int status;
        
        TARGET_INITIALIZE();
         hHandset = codec_open(HANDSET_CODEC);               /* Acquire handle to codec */

    /* Set codec parameters */
    codec_dac_mode(hHandset, CODEC_DAC_15BIT);          /* DAC in 15-bit mode */
    codec_adc_mode(hHandset, CODEC_ADC_15BIT);          /* ADC in 15-bit mode */
    codec_ain_gain(hHandset, CODEC_AIN_0dB);            /* 6dB gain on analog input to ADC */
    codec_aout_gain(hHandset, CODEC_AOUT_MINUS_0dB);    /* -6dB gain on analog output from DAC */
    codec_sample_rate(hHandset,SR_16000);               /* 16KHz sampling rate */


    /* Polling and digital loopback */
    while (1)
    {
       /* Wait for sample from handset */
       while (!MCBSP_RRDY(HANDSET_CODEC)) {};

       /* Read sample from and write back to handset codec */
       data = *(volatile u16*)DRR1_ADDR(HANDSET_CODEC);
       *(volatile u16*)DXR1_ADDR(HANDSET_CODEC) = data;
    
/*
//Open Handset Codec 
hHandset = codec_open(HANDSET_CODEC);               // Acquire handle to codec 

    // Set codec parameters 
codec_adc_mode(hHandset, CODEC_ADC_15BIT);          // ADC in 15-bit mode 
codec_ain_gain(hHandset, CODEC_AIN_0dB);            // 6dB gain on analog input to ADC 
codec_sample_rate(hHandset,SR_16000);               // 16KHz sampling rate, must change to 22 kHz 

for (sample_var = 0; sample_var != 57; ++sample_var)  { 
		   // Wait for sample from handset 
       while (!MCBSP_RRDY(HANDSET_CODEC)) {};

       // Read sample from handset codec 
       data = *(volatile u16*)DRR1_ADDR(HANDSET_CODEC);
 */       
	RTDX_enableOutput( &ochan );	//enable the output channel

	status = RTDX_write( &ochan, &data, sizeof(data) );	//send the data to the host


        if ( status == 0 ) {
                puts( "ERROR: RTDX_write failed!\n" );
                exit( -1 );
        }

        while ( RTDX_writing != NULL ) {
			#if RTDX_POLLING_IMPLEMENTATION
                RTDX_Poll();
			#endif
        }

        
RTDX_disableOutput( &ochan );	//disable the output 

        printf( " %d ", data);
    }
} 
