#include <board.h>
#include <stdio.h>		//needed for printf
#include  "myirtercfg.h"		//needed for csl use
#include <csl.h>
#include <csl_irq.h>


/*****************************************************************************/
/* Function Prototypes   */
/****************************************************************************/

/* This delay routine does not conflict with DSP/BIOS.  It is used in this  */
/* example rather than brd_delay_msec which causes DSP/BIOS conflicts just  */
/* because of this.  If you are not using DSP/BIOS, you can change the code */
/* to use brd_delay_msec.                                                   */

void delay(int);

#define NVECTORS 32 /* There are 32 interrupt vectors in a C5402 */

/* Place the interrupt vector table in a CODE section (NOT data section)
*/
#pragma CODE_SECTION (setup_interrupts,"myvec")

Uint16 myIvtTable[NVECTORS]; /* Interrupt vector storage location */

/* External interrupt handler - must be defined using the "interrupt"
keyword if written in C */

extern interrupt void int0_interrupt();

IRQ_Config MyConfig = { 0x0000, 0x0000, 0x0300};

void setup_interrupts()
{
    //IRQ_setVecs (0x8000);
    //IRQ_setVecs (myIvtTable); /* Set the location of the interrupt vector table defined above */
    //IRQ_plug(IRQ_EVT_INT0, &int0_interrupt); /* Set the interrupt handler location */
    IRQ_enable(IRQ_EVT_INT0); /* Enable the int0 interrupt */
    IRQ_globalEnable(); /* Globally enable interrupts */
    IRQ_config(IRQ_EVT_INT0,&MyConfig);
}


/*****************************************************************************/
/* MAIN */
/*****************************************************************************/

void main()
{
	brd_init(100);
	setup_interrupts();
	
	/* blink all 3 DSK leds forever */
	while (1)
	{
		brd_led_toggle(BRD_LED0);

		/* brd_delay_msec(1000); */
		delay(1000);
        
		brd_led_toggle(BRD_LED1);

		/* brd_delay_msec(1000); */
		delay(1000);
        
		brd_led_toggle(BRD_LED2);
		
		/* brd_delay_msec(1000); */
		delay(1000);
	
		
	} 
}


void delay(int period)
{
    int i, j;
    
    for(i=0; i<period; i++)
    {
        for(j=0; j<period>>1; j++);
    }
}

extern interrupt void int0_interrupt()
{
asm("	RSBX 	1, 13");
}
