;
;  Copyright 2001 by Texas Instruments Incorporated.
;  All rights reserved. Property of Texas Instruments Incorporated.
;  Restricted rights to use, duplicate or disclose this code are
;  granted through contract.
;  
;
; "@(#) DSP/BIOS 4.60.22 12-07-01 (barracuda-j15)"
;
;  ======== vectors.asm ========
;  Plug in the entry point at RESET in the interrupt vector table
;
;
;  ======== unused ========
;  plug inifinite loop -- with nested branches to
;  disable interrupts -- for all undefined vectors
;

        .sect ".vectors"

        .ref 	_c_int00           ; C entry point
		.ref	_interrupt1			;Define global symbol.

        .align  0x80            ; must be aligned on page boundary

RESET:                          ; reset vector
        BD _c_int00                             ; branch to C entry point
        STM #200,SP                             ; stack size of 200
nmi:    RETE                    ; enable interrupts and return from one
                NOP
                NOP
                NOP                                     ;NMI~

                ; software interrupts
sint17:	rete					;Software interrupt 17
				nop
				nop
				nop
			
sint18:	rete					;Software interrupt 18
				nop
				nop
				nop
			
sint19:	rete					;Software interrupt 19
				nop
				nop
				nop
			
sint20:	rete					;Software interrupt 20
				nop
				nop
				nop
		
sint21:	rete					;Software interrupt 21
				nop
				nop
				nop
		
sint22:	rete					;Software interrupt 22
				nop
				nop
				nop
			
sint23:	rete					;Software interrupt 23
				nop
				nop
				nop
		
sint24:	rete					;Software interrupt 24
				nop
				nop
				nop
			
sint25:	rete					;Software interrupt 25
				nop
				nop
				nop
		
sint26:	rete					;Software interrupt 26
				nop
				nop
				nop
		
sint27:	rete					;Software interrupt 27
				nop
				nop
				nop
		
sint28:	rete					;Software interrupt 28
				nop
				nop
				nop
		
sint29:	rete					;Software interrupt 29
				nop
				nop
				nop
		
sint30:	rete					;Software interrupt 30
				nop
				nop
				nop	

int0: 	b _interrupt1
				nop
				nop
int1:   RETE
                NOP 
                NOP
                NOP
int2:   RETE
                NOP
                NOP
                NOP
tint:   RETE
                NOP
                NOP
                NOP
rint0:  RETE
                NOP
                NOP
                NOP
xint0:  RETE
                NOP
                NOP
                NOP
rint1:  RETE
                NOP
                NOP
                NOP
xint1:  RETE
                NOP
                NOP
                NOP
int3:   RETE
                NOP
                NOP
                NOP
                .end
